start dmh_wish -tclargs "proc start args {} ; proc goto args {} ; source claPedestalCurve.bat"
goto EndOfTcl

#  mill truck pedestal contour across 4 parts on substrate

# top of 3/16R arc is at y=0, 1/8 ball cutter, y +/- .106 covers part, x +/- 1.6
#  arc lower as y differs from 0



global R, zmax
set R 0.1875
# 5/16 diameter cutter
set Rcutter [expr {5.0/32}]
set R [expr {$R + $Rcutter}]    ;# convex arc

set zmax 0.0

proc z {y} {
    global R zmax
    set theta [expr {asin($y/$R)}]
    # take off more from zmax as you go farther from y=0 and theta is larger
    set z [expr {$zmax - $R * (1.0 - cos($theta))}]
    return $z
    }

set xmax 1.6
set xmin -1.6
set ymax .106
set ymin [expr {0.0 - $ymax}]
set ydiff [expr {$ymax - $ymin}]

proc prolog {} {
    global xmin ymax
    puts "(code from claPedestalCurve.bat [::dmh::localtime 16])"
    puts "(blank in vise top of arc along y=0, 4 parts .13 apart)"
    puts "( 0,0,0 is z top, x center, y .344 above y blank center, with 5/16 ball cutter)"
    puts "( cutting starts at upper left corner xmin, ymax )"
    puts "(--- typical prolog --)"
    puts "G40 G80 G17 G90 G94"
    # puts "(#904 = 1.8 set plunge rate)"
    puts "#905 = 18.8 (set feed rate)"
    puts "(T12 M06 G43 H12)"
    puts  "S4500 M3"
    puts [format "G0 X%.5f Y%.5f Z0.1" $xmin $ymax]
    puts "G0 Z0.00200"
    puts "G1 F#905 Z0.0 (plunge to set feed rate)"
    }

prolog

set steps 25
set dir 0
for {set i $steps} {$i >= 0} {incr i -1} {
    set p [expr {double($i)/double($steps)}]
    set y [expr {$ymin + $p * $ydiff}]
    set z [z $y]
    if { $dir == 0} {
        # already at xmin
        puts [format "G1 Y%.5f Z%.5f" $y $z]
        puts [format "G1 X%.5f" $xmax]
     } else {
        # at xmax
        puts [format "G1 Y%.5f Z%.5f" $y $z]
        puts [format "G1 X%.5f" $xmin]
     }
     set dir [expr {1 - $dir}]
     }

puts "(--- epilog ---)"
puts "G0 Z4"
puts "M2"
        
console show
return


# \
:EndOfTcl 
